您的位置:首页 > 其它

HDU 4049 Tourism Planning(动态规划)

2014-11-05 20:56 267 查看


Tourism Planning


Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)


Total Submission(s): 1051 Accepted Submission(s): 460

Problem Description

Several friends are planning to take tourism during the next holiday. They have selected some places to visit. They have decided which place to start their tourism and in which order to visit these places. However, anyone can leave halfway during the tourism
and will never back to the tourism again if he or she is not interested in the following places. And anyone can choose not to attend the tourism if he or she is not interested in any of the places.

Each place they visited will cost every person certain amount of money. And each person has a positive value for each place, representing his or her interest in this place. To make things more complicated, if two friends visited a place together, they will
get a non negative bonus because they enjoyed each other’s companion. If more than two friends visited a place together, the total bonus will be the sum of each pair of friends’ bonuses.

Your task is to decide which people should take the tourism and when each of them should leave so that the sum of the interest plus the sum of the bonuses minus the total costs is the largest. If you can’t find a plan that have a result larger than 0, just
tell them to STAY HOME.

Input

There are several cases. Each case starts with a line containing two numbers N and M ( 1<=N<=10, 1<=M<=10). N is the number of friends and M is the number of places. The next line will contain M integers Pi (1<=i<=M) , 1<=Pi<=1000, representing how much it
costs for one person to visit the ith place. Then N line follows, and each line contains M integers Vij (1<=i<=N, 1<=j<=M), 1<=Vij<=1000, representing how much the ith person is interested in the jth place. Then N line follows, and each line contains N integers
Bij (1<=i<=N, 1<=j<=N), 0<=Bij<=1000, Bij=0 if i=j, Bij=Bji.

A case starting with 0 0 indicates the end of input and you needn’t give an output.

Output

For each case, if you can arrange a plan lead to a positive result, output the result in one line, otherwise, output STAY HOME in one line.

Sample Input

2 1
10
15
5
0 5
5 0
3 2
30 50
24 48
40 70
35 20
0 4 1
4 0 5
1 5 0
2 2
100 100
50 50
50 50
0 20
20 0
0 0


Sample Output

5
41
STAY HOME


Source

The 36th ACM/ICPC Asia Regional
Beijing Site —— Online Contest

Recommend

lcy | We have carefully selected several similar problems for you: 4050 4044 4042 4048 4047

题目大意:


输入描述:

第一行两个数字表示,有n个人,m个城市

接下来 m个数字表示每个人参观这些城市的花费

接下来n行m列表示每个人参观每个城市得到的满意度

接下来n行n列表示每参观一个城市互相之间的影响的额外满意度,Bij (1<=i<=N, 1<=j<=N), 0<=Bij<=1000, Bij=0 if i=j, Bij=Bji.

你可以安排这n个人中的任意多个依次参观这m个城市0~m-1,中途也可以让一个人退出,退出后不能再回来,问你最大的值?

值 = 每个人参观每个城市得到的满意度的和 + 互相之间的影响增加的满意度和 - 参观花费和 。



解题思路:


这题的核心是DP

(1)因为n<=10 ,m<=10 ,数据比较小,可以考虑比较暴力的做法,DP就是一个很好的暴力。

(2)很容易就想到这样的DP方程 DP[sum][k]=max{ DP[son][k+1] } + value[sum][k];

sum 就是用2进制表示的有哪些人,son就是sum的子状态,表示sum中一些人半途离开了还剩下的人,

k表示当前是在访问到哪个城市了,DP[sum][k]记录的是在这个状态下要求的最大值。

当有sum这些人访问到k这个城市时候,这时候中途退了一些人,转移到了son这些人,k+1城市 这个状态

转移的花费就是 sum这些人在k这个城市获得的总值,记为 value[sum][k]。

(3)唯一有点麻烦的就是value[sum][k]的数据预处理,这个暴力枚举。



解题代码:

#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
using namespace std;

const int maxn=11;
int n,m;//n people,m cities
int cost[maxn],a[maxn][maxn],b[maxn][maxn];
int dp[(1<<maxn)][maxn],vis[(1<<maxn)][maxn],val[(1<<maxn)][maxn],marked;

void input(){
marked++;
for(int i=0;i<m;i++) scanf("%d",&cost[i]);
for(int i=0;i<n;i++){
for(int j=0;j<m;j++){
scanf("%d",&a[i][j]);
}
}
for(int i=0;i<n;i++){
for(int j=0;j<n;j++){
scanf("%d",&b[i][j]);
}
}
for(int i=0;i<m;i++){
for(int sum=0;sum<(1<<n);sum++){
val[sum][i]=0;
for(int p1=0;p1<n;p1++){
if( !((1<<p1)&sum) ) continue;
for(int p2=0;p2<p1;p2++){
if( (1<<p2)&sum ){
val[sum][i]+=b[p1][p2];
}
}
val[sum][i]+=a[p1][i]-cost[i];
}
}
}
}

int DP(int sum,int k){
if(k>=m) return 0;
if(vis[sum][k]==marked) return dp[sum][k];
int ans=0;
for(int x=sum;x!=0;x=(x-1)&sum ){//for every son state
int tmp=DP(x,k+1)+val[sum][k];
if(tmp>ans) ans=tmp;
}
vis[sum][k]=marked;
return dp[sum][k]=ans;
}

void solve(){
int ans=0;
for(int i=0;i<(1<<n);i++){
if(DP(i,0)>ans) ans=DP(i,0);
}
if(ans==0) printf("STAY HOME\n");
else printf("%d\n",ans);
}

int main(){
while(scanf("%d%d",&n,&m)!=EOF && (n||m) ){
input();
solve();
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: